"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BaseInput =
/*#__PURE__*/
function (_React$Component) {
  _inherits(BaseInput, _React$Component);

  function BaseInput() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, BaseInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(BaseInput)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "closePopup", function () {
      _this.setState({
        popupIsClosed: true
      }, _this.onPopupClose);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onPopupClose", function () {
      // When `closable` prop is true on *Input element
      // `this.closePopup` is invoked after selection complete.
      // To allow popup to be opened again we need to set
      // `popupIsClosed` to false
      // Also `this.closePopup` is used when we force popup to close on blur
      // when using Tab navigation
      _this.setState({
        popupIsClosed: false
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isPickerInFocus", function () {
      return document.activeElement === _this.calendarNode;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isTriggerInFocus", function () {
      return document.activeElement === _this.inputNode;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onModeSwitch", function () {
      // when using keyboard for selecting values on inline calendar
      // and when mode switches, picker looses focus.
      // In order to preserve focus on active picker
      // we call focus() on `calendarNode`.
      // `calendarNode` goes from *View component via
      // `this.onCalendarViewMount` callback
      if (_this.props.inline && !_this.isPickerInFocus()) {
        _this.calendarNode && _this.calendarNode.focus();
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onCalendarViewMount", function (calendarNode) {
      _this.calendarNode = calendarNode;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onInputViewMount", function (inputNode) {
      _this.inputNode = inputNode;
    });

    return _this;
  }

  return BaseInput;
}(_react.default.Component);

var _default = BaseInput;
exports.default = _default;